import multiprocessing
import datetime
import json

from profito.extract_data.extract_data_page1 import traitement_page1
from profito.extract_data.extract_data_page10 import traitement_page10
from profito.extract_data.extract_data_page11 import traitement_page11
from profito.extract_data.extract_data_page12 import traitement_page12
from profito.extract_data.extract_data_page17 import traitement_page17
from profito.extract_data.extract_data_page2 import traitement_page2
from profito.extract_data.extract_data_page3 import traitement_page3
from profito.extract_data.extract_data_page4 import traitement_page4
from profito.extract_data.extract_data_page5 import traitement_page5
from profito.extract_data.extract_data_page7 import traitement_page7
from profito.extract_data.extract_data_page8 import traitement_page8
from profito.extract_data.extract_data_page9 import traitement_page9


def get_json_file_from_liass(file_path: str) -> str:

    # Liste des fonctions de traitement
    traitement_functions = [
        traitement_page1,
        traitement_page2,
        traitement_page3,
        traitement_page4,
        traitement_page5,
        traitement_page7,
        traitement_page8,
        traitement_page9,
        traitement_page10,
        traitement_page11,
        traitement_page12,
        traitement_page17,
    ]
    manager = multiprocessing.Manager()
    resultats_partages = manager.dict()
    processes = []
    for fonction in traitement_functions:
        process = multiprocessing.Process(target=lambda f, args: resultats_partages.update(f(*args)),
                                          args=(fonction, [file_path]))
        processes.append(process)
        process.start()
    for process in processes:
        process.join()

    # Afficher les résultats collectés
    print("Résultats complets:", resultats_partages)
    nom_fichier = ('../'+resultats_partages.get("Désignation de l'entreprise", "NULL") + '_' +
                   resultats_partages.get("SIRET", "NULL") + '_' + str(
                datetime.date.today().year) + '.json')

    # Écrire le dictionnaire dans le fichier JSON
    with open(nom_fichier, 'w', encoding='utf-8') as f:
        json.dump(dict(resultats_partages), f)
    return str(nom_fichier)
if __name__ == "__main__":
    get_json_file_from_liass("../2050-liasse_4225_page1-8_full.pdf")

